Page MenuHomePhabricator

AMDGPU: Make i64 loads/stores promote to v2i32
ClosedPublic

Authored by arsenm on Feb 12 2016, 3:59 PM.

Details

Reviewers
tstellarAMD
Summary

Now that unaligned access expansion should not attempt
to produce i64 accesses, we can remove the hack in
PreprocessISelDAG where this is done.

This allows splitting i64 private accesses while
allowing the new add nodes indexing the vector components
can be folded with the base pointer arithmetic.

Diff Detail

Event Timeline

arsenm updated this revision to Diff 47872.Feb 12 2016, 3:59 PM
arsenm retitled this revision from to AMDGPU: Make i64 loads/stores promote to v2i32.
arsenm updated this object.
arsenm added a reviewer: tstellarAMD.
arsenm added a subscriber: llvm-commits.

The problem with this is that the promoted node counts as legalized, so the custom lowering for v2i32 is never called for it, so we can't split it up when necessary for private accesses

tstellarAMD accepted this revision.Feb 16 2016, 3:47 PM
tstellarAMD edited edge metadata.

LGTM.

This revision is now accepted and ready to land.Feb 16 2016, 3:47 PM
arsenm closed this revision.May 2 2016, 1:13 PM

r268293